/*
 * ***********************************************
 * 
 * !!!! DO NOT EDIT !!!!
 * 
 * This file was auto-generated by Build.PL.
 * 
 * ***********************************************
 * 
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#define CFP_CFISH

#include "cfish_perl.h"
#include "XSBind.h"
#include "Clownfish/Class.h"
#include "Clownfish/Err.h"
#include "Clownfish/Obj.h"
#include "Clownfish/Obj.h"
#include "Clownfish/String.h"
#include "Clownfish/String.h"
#include "Clownfish/HashIterator.h"
#include "Clownfish/Vector.h"
#include "Clownfish/Method.h"
#include "Clownfish/Boolean.h"
#include "Clownfish/Class.h"
#include "Clownfish/TestHarness/TestSuiteRunner.h"
#include "Clownfish/TestHarness/TestFormatter.h"
#include "Clownfish/TestHarness/TestFormatter.h"
#include "Clownfish/TestHarness/TestFormatter.h"
#include "Clownfish/TestHarness/TestBatchRunner.h"
#include "Clownfish/TestHarness/TestSuite.h"
#include "Clownfish/TestHarness/TestBatch.h"
#include "Clownfish/Blob.h"
#include "Clownfish/CharBuf.h"
#include "Clownfish/Num.h"
#include "Clownfish/Num.h"
#include "Clownfish/ByteBuf.h"
#include "Clownfish/Err.h"
#include "Clownfish/Hash.h"

/* Avoid conflicts with Clownfish bool type. */
#define HAS_BOOL
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

static void
S_finish_callback_void(pTHX_ const char *meth_name) {
    int count = call_method(meth_name, G_VOID | G_DISCARD);
    if (count != 0) {
        CFISH_THROW(CFISH_ERR, "Bad callback to '%s': %i32",
                    meth_name, (int32_t)count);
    }
    FREETMPS;
    LEAVE;
}

static CFISH_INLINE SV*
SI_do_callback_sv(pTHX_ const char *meth_name) {
    int count = call_method(meth_name, G_SCALAR);
    if (count != 1) {
        CFISH_THROW(CFISH_ERR, "Bad callback to '%s': %i32",
                    meth_name, (int32_t)count);
    }
    dSP;
    SV *return_sv = POPs;
    PUTBACK;
    return return_sv;
}

static int64_t
S_finish_callback_i64(pTHX_ const char *meth_name) {
    SV *return_sv = SI_do_callback_sv(aTHX_ meth_name);
    int64_t retval;
    if (sizeof(IV) == 8) {
        retval = (int64_t)SvIV(return_sv);
    }
    else {
        if (SvIOK(return_sv)) {
            // It's already no more than 32 bits, so don't convert.
            retval = SvIV(return_sv);
        }
        else {
            // Maybe lossy.
            double temp = SvNV(return_sv);
            retval = (int64_t)temp;
        }
    }
    FREETMPS;
    LEAVE;
    return retval;
}

static double
S_finish_callback_f64(pTHX_ const char *meth_name) {
    SV *return_sv = SI_do_callback_sv(aTHX_ meth_name);
    double retval = SvNV(return_sv);
    FREETMPS;
    LEAVE;
    return retval;
}

static cfish_Obj*
S_finish_callback_obj(pTHX_ void *vself, const char *meth_name,
                      int nullable) {
    SV *return_sv = SI_do_callback_sv(aTHX_ meth_name);
    cfish_Obj *retval
        = XSBind_perl_to_cfish_nullable(aTHX_ return_sv, CFISH_OBJ);
    FREETMPS;
    LEAVE;
    if (!nullable && !retval) {
        CFISH_THROW(CFISH_ERR, "%o#%s cannot return NULL",
                    cfish_Obj_get_class_name((cfish_Obj*)vself),
                    meth_name);
    }
    return retval;
}

void*
Cfish_Obj_To_Host_OVERRIDE(cfish_Obj* self, void* vcache) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(vcache);
    cfish_Err_invalid_callback("to_host");
    CFISH_UNREACHABLE_RETURN(void*);
}

cfish_Obj*
Cfish_Obj_Clone_OVERRIDE(cfish_Obj* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(aTHX_ self, "clone", false);
    return retval;
}

bool
Cfish_Obj_Equals_OVERRIDE(cfish_Obj* self, cfish_Obj* other) {
    dTHX;
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)other));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64(aTHX_ "equals");
    return retval;
}

int32_t
Cfish_Obj_Compare_To_OVERRIDE(cfish_Obj* self, cfish_Obj* other) {
    dTHX;
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)other));
    PUTBACK;
    int32_t retval = (int32_t)S_finish_callback_i64(aTHX_ "compare_to");
    return retval;
}

void
Cfish_Obj_Destroy_OVERRIDE(cfish_Obj* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    S_finish_callback_void(aTHX_ "DESTROY");
}

cfish_String*
Cfish_Obj_To_String_OVERRIDE(cfish_Obj* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(aTHX_ self, "to_string", false);
    return retval;
}

bool
Cfish_TestSuiteRunner_Run_Batch_OVERRIDE(cfish_TestSuiteRunner* self, cfish_TestBatch* batch) {
    dTHX;
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)batch));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64(aTHX_ "run_batch");
    return retval;
}

bool
Cfish_TestSuiteRunner_Finish_OVERRIDE(cfish_TestSuiteRunner* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64(aTHX_ "finish");
    return retval;
}

uint32_t
Cfish_TestSuiteRunner_Get_Num_Tests_OVERRIDE(cfish_TestSuiteRunner* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64(aTHX_ "get_num_tests");
    return retval;
}

uint32_t
Cfish_TestSuiteRunner_Get_Num_Tests_Failed_OVERRIDE(cfish_TestSuiteRunner* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64(aTHX_ "get_num_tests_failed");
    return retval;
}

uint32_t
Cfish_TestSuiteRunner_Get_Num_Batches_OVERRIDE(cfish_TestSuiteRunner* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64(aTHX_ "get_num_batches");
    return retval;
}

uint32_t
Cfish_TestSuiteRunner_Get_Num_Batches_Failed_OVERRIDE(cfish_TestSuiteRunner* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64(aTHX_ "get_num_batches_failed");
    return retval;
}

void
Cfish_TestFormatter_Batch_Prologue_OVERRIDE(cfish_TestFormatter* self, cfish_TestBatch* batch, uint32_t num_planned) {
    dTHX;
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHp("batch", 5);
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)batch));
    mPUSHp("num_planned", 11);
    mPUSHi(num_planned);
    PUTBACK;
    S_finish_callback_void(aTHX_ "batch_prologue");
}

void
Cfish_TestFormatter_VTest_Result_OVERRIDE(cfish_TestFormatter* self, bool pass, uint32_t test_num, const char* fmt, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(pass);
    CFISH_UNUSED_VAR(test_num);
    CFISH_UNUSED_VAR(fmt);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vtest_result");
}

void
Cfish_TestFormatter_VTest_Skip_OVERRIDE(cfish_TestFormatter* self, uint32_t test_num, uint32_t num_skipped, const char* fmt, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(test_num);
    CFISH_UNUSED_VAR(num_skipped);
    CFISH_UNUSED_VAR(fmt);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vtest_skip");
}

void
Cfish_TestFormatter_VTest_Comment_OVERRIDE(cfish_TestFormatter* self, const char* fmt, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(fmt);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vtest_comment");
}

void
Cfish_TestFormatter_VBatch_Comment_OVERRIDE(cfish_TestFormatter* self, const char* fmt, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(fmt);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vbatch_comment");
}

void
Cfish_TestFormatter_Summary_OVERRIDE(cfish_TestFormatter* self, cfish_TestSuiteRunner* runner) {
    dTHX;
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)runner));
    PUTBACK;
    S_finish_callback_void(aTHX_ "summary");
}

bool
Cfish_TestBatchRunner_Run_Batch_OVERRIDE(cfish_TestBatchRunner* self, cfish_TestBatch* batch) {
    dTHX;
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)batch));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64(aTHX_ "run_batch");
    return retval;
}

void
Cfish_TestBatchRunner_Plan_OVERRIDE(cfish_TestBatchRunner* self, cfish_TestBatch* batch, uint32_t num_planned) {
    dTHX;
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHp("batch", 5);
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)batch));
    mPUSHp("num_planned", 11);
    mPUSHi(num_planned);
    PUTBACK;
    S_finish_callback_void(aTHX_ "plan");
}

uint32_t
Cfish_TestBatchRunner_Get_Num_Planned_OVERRIDE(cfish_TestBatchRunner* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64(aTHX_ "get_num_planned");
    return retval;
}

uint32_t
Cfish_TestBatchRunner_Get_Num_Tests_OVERRIDE(cfish_TestBatchRunner* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64(aTHX_ "get_num_tests");
    return retval;
}

uint32_t
Cfish_TestBatchRunner_Get_Num_Failed_OVERRIDE(cfish_TestBatchRunner* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64(aTHX_ "get_num_failed");
    return retval;
}

bool
Cfish_TestBatchRunner_VTest_True_OVERRIDE(cfish_TestBatchRunner* self, bool condition, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(condition);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vtest_true");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VTest_False_OVERRIDE(cfish_TestBatchRunner* self, bool condition, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(condition);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vtest_false");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VTest_Int_Equals_OVERRIDE(cfish_TestBatchRunner* self, int64_t got, int64_t expected, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(got);
    CFISH_UNUSED_VAR(expected);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vtest_int_equals");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VTest_UInt_Equals_OVERRIDE(cfish_TestBatchRunner* self, uint64_t got, uint64_t expected, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(got);
    CFISH_UNUSED_VAR(expected);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vtest_uint_equals");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VTest_Float_Equals_OVERRIDE(cfish_TestBatchRunner* self, double got, double expected, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(got);
    CFISH_UNUSED_VAR(expected);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vtest_float_equals");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VTest_String_Equals_OVERRIDE(cfish_TestBatchRunner* self, const char* got, const char* expected, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(got);
    CFISH_UNUSED_VAR(expected);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vtest_string_equals");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VPass_OVERRIDE(cfish_TestBatchRunner* self, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vpass");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VFail_OVERRIDE(cfish_TestBatchRunner* self, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vfail");
    CFISH_UNREACHABLE_RETURN(bool);
}

void
Cfish_TestBatchRunner_VSkip_OVERRIDE(cfish_TestBatchRunner* self, uint32_t num, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(num);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    cfish_Err_invalid_callback("vskip");
}

void
Cfish_TestSuite_Add_Batch_OVERRIDE(cfish_TestSuite* self, cfish_TestBatch* batch) {
    dTHX;
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)batch));
    PUTBACK;
    S_finish_callback_void(aTHX_ "add_batch");
    CFISH_DECREF(batch);
}

bool
Cfish_TestSuite_Run_Batch_OVERRIDE(cfish_TestSuite* self, cfish_String* class_name, cfish_TestFormatter* formatter) {
    dTHX;
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHp("class_name", 10);
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)class_name));
    mPUSHp("formatter", 9);
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)formatter));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64(aTHX_ "run_batch");
    return retval;
}

bool
Cfish_TestSuite_Run_All_Batches_OVERRIDE(cfish_TestSuite* self, cfish_TestFormatter* formatter) {
    dTHX;
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)formatter));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64(aTHX_ "run_all_batches");
    return retval;
}

void
Cfish_TestBatch_Run_OVERRIDE(cfish_TestBatch* self, cfish_TestBatchRunner* runner) {
    dTHX;
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)runner));
    PUTBACK;
    S_finish_callback_void(aTHX_ "run");
}

void
Cfish_Err_Cat_Mess_OVERRIDE(cfish_Err* self, cfish_String* mess) {
    dTHX;
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    mPUSHs(XSBind_cfish_to_perl(aTHX_ (cfish_Obj*)mess));
    PUTBACK;
    S_finish_callback_void(aTHX_ "cat_mess");
}

cfish_String*
Cfish_Err_Get_Mess_OVERRIDE(cfish_Err* self) {
    dTHX;
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self, NULL));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(aTHX_ self, "get_mess", false);
    CFISH_DECREF(retval);
    return retval;
}

void
Cfish_Err_Add_Frame_OVERRIDE(cfish_Err* self, const char* file, int line, const char* func) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(file);
    CFISH_UNUSED_VAR(line);
    CFISH_UNUSED_VAR(func);
    cfish_Err_invalid_callback("add_frame");
}


void
cfish_bootstrap_perl() {
    dTHX;
    cfish_bootstrap_parcel();

    CFISH_Class_Add_Host_Method_Alias(CFISH_OBJ, "DESTROY", "Destroy");
    CFISH_Class_Exclude_Host_Method(CFISH_STRINGITERATOR, "Next");
    CFISH_Class_Exclude_Host_Method(CFISH_STRINGITERATOR, "Prev");
    CFISH_Class_Exclude_Host_Method(CFISH_VECTOR, "Store");
    CFISH_Class_Exclude_Host_Method(CFISH_HASH, "Store");
}

